diff -Nru sogo-5.0.1/UI/WebServerResources/js/Common/Authentication.service.js sogo-5.2.0/UI/WebServerResources/js/Common/Authentication.service.js
--- sogo-5.0.1/UI/WebServerResources/js/Common/Authentication.service.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Common/Authentication.service.js	2021-08-18 21:35:57.000000000 +0200
@@ -31,7 +31,7 @@
 
       userName = username;
       if (domain)
-        userName += '@' + domain.value;
+        userName += '@' + domain;
       address = '' + window.location.href;
       baseAddress = ApplicationBaseURL + encodeURIComponent(userName);
       if (baseAddress[0] == '/') {
@@ -93,53 +93,75 @@
               d.reject({error: l('cookiesNotEnabled')});
             }
             else {
-              // Check for Google Authenticator 2FA
-              if (typeof data.GoogleAuthenticatorMissingKey != 'undefined' && response.status == 202) {
-                d.resolve({gamissingkey: 1});
+              // Check for TOTP
+              if (typeof data.totpMissingKey != 'undefined' && response.status == 202) {
+                d.resolve({totpmissingkey: 1});
               }
               // Check password policy
               else if (typeof data.expire != 'undefined' && typeof data.grace != 'undefined') {
                 if (data.expire < 0 && data.grace > 0) {
-                  d.reject({grace: data.grace});
-                  //showPasswordDialog('grace', createPasswordGraceDialog, data['grace']);
+                  d.reject({
+                    cn: data.cn,
+                    url: redirectUrl(username, domain),
+                    grace: data.grace
+                  });
                 } else if (data.expire > 0 && data.grace == -1) {
-                  d.reject({expire: data.expire});
-                  //showPasswordDialog('expiration', createPasswordExpirationDialog, data['expire']);
+                  d.reject({
+                    cn: data.cn,
+                    url: redirectUrl(username, domain),
+                    expire: data.expire
+                  });
                 }
                 else {
-                  d.resolve({ cn: data.cn, url: redirectUrl(username, domain) });
+                  d.resolve({
+                    cn: data.cn,
+                    url: redirectUrl(username, domain)
+                  });
                 }
               }
               else {
                 d.resolve({ url: redirectUrl(username, domain) });
               }
             }
-          }, function(response) {
-            var msg, perr, data = response.data;
-            if (data && data.GoogleAuthenticatorInvalidKey) {
-              msg = l('You provided an invalid Google Authenticator key.');
+          }, function(error) {
+            var response, perr, data = error.data;
+            if (data && data.totpInvalidKey) {
+              response = {error: l('You provided an invalid TOTP key.')};
             }
-            else if (data && data.LDAPPasswordPolicyError) {
+            else if (data && angular.isDefined(data.LDAPPasswordPolicyError)) {
               perr = data.LDAPPasswordPolicyError;
               if (perr == passwordPolicyConfig.PolicyNoError) {
-                msg = l('Wrong username or password.');
+                response = {error: l('Wrong username or password.')};
               }
               else if (perr == passwordPolicyConfig.PolicyAccountLocked) {
-                msg = l('Your account was locked due to too many failed attempts.');
+                response = {error: l('Your account was locked due to too many failed attempts.')};
+              }
+              else if (perr == passwordPolicyConfig.PolicyPasswordExpired ||
+                       perr == passwordPolicyConfig.PolicyChangeAfterReset) {
+                response = {
+                  passwordexpired: 1,
+                  url: redirectUrl(username, domain)
+                };
+              }
+              else if (perr == passwordPolicyConfig.PolicyChangeAfterReset) {
+                response = {
+                  passwordexpired: 1,
+                  url: redirectUrl(username, domain)
+                };
               }
               else {
-                msg = l('Login failed due to unhandled error case: ') + perr;
+                response = {error: l('Login failed due to unhandled error case: ') + perr};
               }
             }
             else {
-              msg = l('Unhandled error response');
+              response = {error: l('Unhandled error response')};
             }
-            d.reject({error: msg});
+            d.reject(response);
           });
           return d.promise;
         }, // login: function(data) { ...
 
-        changePassword: function(newPassword, oldPassword) {
+        changePassword: function(userName, domain, newPassword, oldPassword) {
           var d = $q.defer(),
               xsrfCookie = $cookies.get('XSRF-TOKEN');
 
@@ -151,8 +173,10 @@
             headers: {
               'X-XSRF-TOKEN' : xsrfCookie
             },
-            data: { newPassword: newPassword, oldPassword: oldPassword }
-          }).then(d.resolve, function(response) {
+            data: { userName: userName, newPassword: newPassword, oldPassword: oldPassword }
+          }).then(function() {
+            d.resolve({url: redirectUrl(userName, domain)});
+          }, function(response) {
             var error,
                 data = response.data,
                 perr = data.LDAPPasswordPolicyError;
@@ -161,7 +185,8 @@
               perr = passwordPolicyConfig.PolicyPasswordSystemUnknown;
               error = _("Unhandled error response");
             }
-            else if (perr == passwordPolicyConfig.PolicyNoError) {
+            else if (perr == passwordPolicyConfig.PolicyNoError ||
+                     perr == passwordPolicyConfig.PolicyPasswordUnknown) {
               error = l("Password change failed");
             } else if (perr == passwordPolicyConfig.PolicyPasswordModNotAllowed) {
               error = l("Password change failed - Permission denied");
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Common/Common.app.js sogo-5.2.0/UI/WebServerResources/js/Common/Common.app.js
--- sogo-5.0.1/UI/WebServerResources/js/Common/Common.app.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Common/Common.app.js	2021-08-18 21:35:57.000000000 +0200
@@ -185,30 +185,12 @@
       'contrastDarkColors': ['50', '100', '200'],
       // 'contrastLightColors': ['300', '400', '500', '600', '700', '800', '900', 'A100', 'A200', 'A400', 'A700']
     });
-    // Background palette
-    $mdThemingProvider.definePalette('sogo-paper', {
-      '50': 'fcf7f8',
-      '100': 'f7f1dc',
-      '200': 'ede5ca',
-      '300': 'e6d8ba',
-      '400': 'e2d2a3',
-      '500': 'd6c48d',
-      '600': 'baa870',
-      '700': '857545',
-      '800': '524517',
-      '900': '433809',
-      '1000': '000000',
-      'A100': 'ffffff',
-      'A200': 'eeeeee',
-      'A400': 'bdbdbd',
-      'A700': '616161',
-      'contrastDefaultColor': 'dark',
-      'contrastLightColors': ['800', '900']
-    });
+    // Background palette -- extends the grey palette
     var greyMap = $mdThemingProvider.extendPalette('grey', {
       '1000': 'baa870' // used as the background color of the busy periods of the attendees editor
     });
     $mdThemingProvider.definePalette('sogo-grey', greyMap);
+
     // Default theme definition
     $mdThemingProvider.theme('default')
       .primaryPalette('sogo-blue', {
@@ -226,8 +208,20 @@
       })
       .backgroundPalette('sogo-grey');
 
+    // Register custom stylesheet for toolbar of center lists
+    $mdThemingProvider.registerStyles([
+      'md-toolbar.md-hue-1:not(.md-menu-toolbar).md-accent,',
+      'md-toolbar.md-hue-1:not(.md-menu-toolbar).md-accent md-input-container[md-no-float] .md-input {',
+      '  background-color: \'{{accent-hue-1}}\';',
+      '  color: \'{{foreground-1}}\';',
+      '}',
+      'md-toolbar.md-hue-1:not(.md-menu-toolbar).md-accent md-icon {',
+      '  color: \'{{foreground-1}}\';',
+      '  fill: \'{{foreground-1}}\';',
+      '}',
+    ].join(''));
 
-    // Register custom stylesheet for md-autocomplete
+    // Register custom stylesheet for mdAutocomplete
     $mdThemingProvider.registerStyles([
       '.md-autocomplete-suggestions.md-3-line li p {',
       '  color: \'{{foreground-2}}\';',
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Common/Resource.service.js sogo-5.2.0/UI/WebServerResources/js/Common/Resource.service.js
--- sogo-5.0.1/UI/WebServerResources/js/Common/Resource.service.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Common/Resource.service.js	2021-08-18 21:35:57.000000000 +0200
@@ -277,7 +277,7 @@
           fileName = options.filename;
         }
         else {
-          getFileNameFromHeader(headers('content-disposition'));
+          fileName = getFileNameFromHeader(headers('content-disposition'));
         }
         saveAs(blob, fileName);
       }
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Common/sgAutogrow.directive.js sogo-5.2.0/UI/WebServerResources/js/Common/sgAutogrow.directive.js
--- sogo-5.0.1/UI/WebServerResources/js/Common/sgAutogrow.directive.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Common/sgAutogrow.directive.js	2021-08-18 21:35:57.000000000 +0200
@@ -18,8 +18,8 @@
 
      <textarea rows="9" md-no-autogrow sg-autogrow="!isPopup" />
   */
-  sgAutogrow.$inject = ['$document', '$timeout'];
-  function sgAutogrow($document, $timeout) {
+  sgAutogrow.$inject = ['$document', '$timeout', '$mdUtil'];
+  function sgAutogrow($document, $timeout, $mdUtil) {
     return {
       restrict: 'A',
       scope: {
@@ -44,19 +44,17 @@
         textarea.style.overflow = 'hidden';
 
         function AutoGrowTextArea() {
-          $timeout(function() {
-            content = textarea.value.encodeEntities();
-            content = content.replace(/\n/g, '<br>');
-            hiddenDiv.innerHTML = content + '<br style="line-height: 3px;">';
-            hiddenDiv.style.visibility = 'hidden';
-            hiddenDiv.style.display = 'block';
-            textarea.style.height = Math.max(minHeight, hiddenDiv.offsetHeight) + 'px';
-            hiddenDiv.style.visibility = 'visible';
-            hiddenDiv.style.display = 'none';
-          });
+          content = textarea.value.encodeEntities();
+          content = content.replace(/\n/g, '<br>');
+          hiddenDiv.innerHTML = content + '<br style="line-height: 3px;">';
+          hiddenDiv.style.visibility = 'hidden';
+          hiddenDiv.style.display = 'block';
+          textarea.style.height = Math.max(minHeight, hiddenDiv.offsetHeight) + 'px';
+          hiddenDiv.style.visibility = 'visible';
+          hiddenDiv.style.display = 'none';
         }
 
-        elem.on('keyup', AutoGrowTextArea);
+        elem.on('keyup', $mdUtil.debounce(AutoGrowTextArea, 200));
         elem.on('paste', AutoGrowTextArea);
 
         var deregisterWatcher = scope.$watch(function() {
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Common/sgCkeditor.component.js sogo-5.2.0/UI/WebServerResources/js/Common/sgCkeditor.component.js
--- sogo-5.0.1/UI/WebServerResources/js/Common/sgCkeditor.component.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Common/sgCkeditor.component.js	2021-08-18 21:35:57.000000000 +0200
@@ -18,20 +18,16 @@
     // Default plugins that have successfully passed through Angular's $sanitize service
     var defaultConfiguration = {
       toolbarGroups: [
-        { name: 'basicstyles', groups: [ 'basicstyles' ] },
-        { name: 'colors' },
-        { name: 'paragraph', groups: [ 'list', 'indent', 'blocks', 'align' ] },
-        { name: 'links' },
-        { name: 'insert' },
-        { name: 'editing', groups: [ 'spellchecker' ] },
-        { name: 'styles' },
-        { name: 'mode' }
+        { name: 'basicstyles', groups: [ 'basicstyles', 'colors', 'list', 'indent', 'blocks', 'align', 'links', 'insert', 'spellchecker', 'styles', 'mode' ] }
       ],
 
       // The default plugins included in the basic setup define some buttons that
       // are not needed in a basic editor. They are removed here.
       removeButtons: 'Strike,Subscript,Superscript,BGColor,Anchor,Format,Image',
 
+      // Allow the toolbar to be collapsed (useful for small screens)
+      toolbarCanCollapse: true,
+
       // Dialog windows are also simplified.
       removeDialogTabs: 'link:advanced',
 
@@ -323,8 +319,9 @@
     }
 
     this.$onDestroy = function () {
+      var noUpdate = true;
       editorElement.classList.add('ng-cloak');
-      editor.destroy();
+      editor.destroy(noUpdate);
     }
 
     function onInstanceReady (event) {
@@ -356,7 +353,7 @@
 
     function onEditorChange () {
       var html = editor.getData();
-      var body = editor.document.getBody();
+      var body = editor.document ? editor.document.getBody() : null;
       var text;
 
       if (_.isEmpty(body))
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Common/utils.js sogo-5.2.0/UI/WebServerResources/js/Common/utils.js
--- sogo-5.0.1/UI/WebServerResources/js/Common/utils.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Common/utils.js	2021-08-18 21:35:57.000000000 +0200
@@ -210,7 +210,7 @@
       return (i >= 0);
     }],
     '%y': [/\d\d/, function(input) {
-      var nearFuture = parseInt(now.getFullYear().toString().substring(2)) + 5;
+      var nearFuture = parseInt(now.getFullYear().toString().substring(2)) + 50;
       date.year = parseInt(input);
       if (date.year < nearFuture) date.year += 2000;
       else date.year += 1900;
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Mailer/Account.service.js sogo-5.2.0/UI/WebServerResources/js/Mailer/Account.service.js
--- sogo-5.0.1/UI/WebServerResources/js/Mailer/Account.service.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Mailer/Account.service.js	2021-08-18 21:35:57.000000000 +0200
@@ -103,6 +103,61 @@
   };
 
   /**
+   * @memberof Account
+   * @desc Refresh the unseen count for all required mailboxes.
+   *       Starts a timer if user choose to automatically refresh folders.
+   * @param {array} [string] - the paths of the folders
+   */
+  Account.refreshUnseenCount = function(folders) {
+    var unseenCountFolders,
+        fetchAllUnseenCountFolders = (Account.$Preferences.defaults.SOGoMailFetchAllUnseenCountFolders === 1),
+        refreshViewCheck = Account.$Preferences.defaults.SOGoRefreshViewCheck;
+
+    if (fetchAllUnseenCountFolders)
+      unseenCountFolders = [];
+    else if (folders)
+      unseenCountFolders = folders;
+    else
+      throw Error('SOGoMailFetchAllUnseenCountFolders is disabled and no folders list provided');
+
+    _.forEach(Account.$accounts, function(account) {
+      if (fetchAllUnseenCountFolders) {
+        // Include all mailboxes
+        _.forEach(account.$$flattenMailboxes, function(mailbox) {
+          unseenCountFolders.push(mailbox.id);
+        });
+      }
+      else {
+        // Always include the INBOX
+        if (!_.includes(unseenCountFolders, account.id + '/folderINBOX'))
+          unseenCountFolders.push(account.id + '/folderINBOX');
+
+        _.forEach(account.$$flattenMailboxes, function(mailbox) {
+          if (angular.isDefined(mailbox.unseenCount) &&
+              !_.includes(unseenCountFolders, mailbox.id))
+            unseenCountFolders.push(mailbox.id);
+        });
+      }
+    });
+
+    Account.$$resource.post('', 'unseenCount', {mailboxes: unseenCountFolders}).then(function(data) {
+      _.forEach(Account.$accounts, function(account) {
+        _.forEach(account.$$flattenMailboxes, function(mailbox) {
+          if (data[mailbox.id]) {
+            mailbox.unseenCount = data[mailbox.id];
+          }
+        });
+      });
+    });
+
+    if (refreshViewCheck && refreshViewCheck != 'manually') {
+      if (Account.$refreshUnseenCount)
+        Account.$timeout.cancel(Account.$refreshUnseenCount);
+      Account.$refreshUnseenCount = Account.$timeout(angular.bind(this, Account.refreshUnseenCount, folders), refreshViewCheck.timeInterval()*1000);
+    }
+  };
+
+  /**
    * @function getLength
    * @memberof Account.prototype
    * @desc Used by md-virtual-repeat / md-on-demand
@@ -338,6 +393,16 @@
   };
 
   /**
+   * @function $hasCertificate
+   * @memberof Account.prototype
+   * @desc Return true if the user has a S/MIME certificate for this account
+   * @returns a boolean value
+   */
+  Account.prototype.$hasCertificate = function() {
+    return this.security && this.security.hasCertificate;
+  };
+
+  /**
    * @function $certificate
    * @memberof Account.prototype
    * @desc View the S/MIME certificate details associated to the account.
@@ -346,7 +411,7 @@
   Account.prototype.$certificate = function() {
     var _this = this;
 
-    if (this.security && this.security.hasCertificate) {
+    if (this.$hasCertificate()) {
       if (this.$$certificate)
         return Account.$q.when(this.$$certificate);
       else {
@@ -384,9 +449,16 @@
   Account.prototype.updateQuota = function(data) {
     var percent, format, description;
 
-    percent = (Math.round(data.usedSpace * 10000 / data.maxQuota) / 100);
-    format = l("quotasFormat");
-    description = format.formatted(percent, Math.round(data.maxQuota/10.24)/100);
+    if (data.maxQuota) {
+      percent = (Math.round(data.usedSpace * 10000 / data.maxQuota) / 100);
+      format = l("quotasFormat");
+      description = format.formatted(percent, Math.round(data.maxQuota/10.24)/100);
+    }
+    else if (data.maxMessages) {
+      percent = (Math.round(data.messagesCount * 10000 / data.maxMessages) / 100);
+      format = l("messageQuotasFormat");
+      description = format.formatted(percent, data.maxMessages);
+    }
 
     this.$quota = { percent: percent, description: description };
   };
@@ -480,7 +552,7 @@
    * @return an object literal copy of the Account instance
    */
   Account.prototype.$omit = function () {
-    var account = {}, identities = [];
+    var account = {}, identities = [], defaultIdentity = false;
 
     angular.forEach(this, function(value, key) {
       if (key != 'constructor' && key !='identities' && key[0] != '$') {
@@ -491,9 +563,14 @@
     _.forEach(this.identities, function (identity) {
       if (!identity.isReadOnly)
         identities.push(_.pick(identity, ['email', 'fullName', 'replyTo', 'signature', 'isDefault']));
+      if (identity.isDefault)
+        defaultIdentity = identity;
     });
     account.identities = identities;
 
+    if (!defaultIdentity || !account.forceDefaultIdentity)
+      delete account.forceDefaultIdentity;
+
     return account;
   };
 
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Mailer/MailboxController.js sogo-5.2.0/UI/WebServerResources/js/Mailer/MailboxController.js
--- sogo-5.0.1/UI/WebServerResources/js/Mailer/MailboxController.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Mailer/MailboxController.js	2021-08-18 21:35:57.000000000 +0200
@@ -165,10 +165,10 @@
 
     this.cancelSearch = function() {
       vm.mode.search = false;
-      vm.selectedFolder.$filter().then(function() {
-        if (vm.selectedFolder.selectedMessage) {
+      vm.selectedFolder.$filter(vm.service.$query).then(function() {
+        if (vm.selectedFolder.$selectedMessage) {
           $timeout(function() {
-            vm.selectedFolder.$topIndex = vm.selectedFolder.uidsMap[vm.selectedFolder.selectedMessage];
+            vm.selectedFolder.$topIndex = vm.selectedFolder.uidsMap[vm.selectedFolder.$selectedMessage];
           });
         }
       });
@@ -320,14 +320,14 @@
           selectedIndex, nextSelectedIndex, i;
 
       if (!message)
-        message = folder.$selectedMessage();
+        message = folder.selectedMessage();
       if (!message)
         return true;
+
       message.selected = !message.selected;
-      vm.mode.multiple += message.selected? 1 : -1;
 
       // Select closest range of messages when shift key is pressed
-      if ($event.shiftKey && folder.$selectedCount() > 1) {
+      if ($event.shiftKey && folder.selectedCount() > 0) {
         selectedIndex = folder.uidsMap[message.uid];
         // Search for next selected message above
         nextSelectedIndex = selectedIndex - 2;
@@ -349,6 +349,8 @@
         }
       }
 
+      folder.selectedMessages({ updateCache: true });
+      vm.mode.multiple = vm.selectedFolder.selectedCount();
       $event.preventDefault();
       $event.stopPropagation();
     };
@@ -368,7 +370,7 @@
     // This function must not be called in virtual mode.
     function _unselectMessage(message, index) {
       var nextMessage, previousMessage, nextIndex = index;
-      vm.mode.multiple = vm.selectedFolder.$selectedCount();
+      vm.mode.multiple = vm.selectedFolder.selectedCount();
       if (message) {
         // Select either the next or previous message
         if (index > 0) {
@@ -395,16 +397,10 @@
           $state.go('mail.account.mailbox');
         }
       }
-      else {
-        $timeout(function() {
-          console.warn('go to mailbox');
-          $state.go('mail.account.mailbox');
-        });
-      }
     }
 
     this.confirmDeleteSelectedMessages = function($event) {
-      var selectedMessages = vm.selectedFolder.$selectedMessages();
+      var selectedMessages = vm.selectedFolder.selectedMessages();
 
       if (vm.messageDialog === null && _.size(selectedMessages) > 0)
         vm.messageDialog = Dialog.confirm(l('Confirmation'),
@@ -456,9 +452,10 @@
 
     this.markOrUnMarkMessagesAsJunk = function() {
       var moveSelectedMessage = vm.selectedFolder.hasSelectedMessage();
-      var selectedMessages = vm.selectedFolder.$selectedMessages();
+      var selectedMessages = vm.selectedFolder.selectedMessages();
       if (_.size(selectedMessages) === 0 && moveSelectedMessage)
-        selectedMessages = [vm.selectedFolder.$selectedMessage()];
+        // No selection, user has pressed keyboard shortcut
+        selectedMessages = [vm.selectedFolder.selectedMessage()];
       if (_.size(selectedMessages) > 0)
         vm.selectedFolder.$markOrUnMarkMessagesAsJunk(selectedMessages).then(function() {
           var dstFolder = '/' + vm.account.id + '/folderINBOX';
@@ -481,12 +478,12 @@
     };
 
     this.copySelectedMessages = function(dstFolder) {
-      var selectedMessages = vm.selectedFolder.$selectedMessages();
+      var selectedMessages = vm.selectedFolder.selectedMessages();
       if (_.size(selectedMessages) > 0)
         vm.selectedFolder.$copyMessages(selectedMessages, '/' + dstFolder).then(function() {
           $mdToast.show(
             $mdToast.simple()
-              .textContent(l('%{0} message(s) copied', vm.selectedFolder.$selectedCount()))
+              .textContent(l('%{0} message(s) copied', vm.selectedFolder.selectedCount()))
               .position('top right')
               .hideDelay(2000));
         });
@@ -494,8 +491,8 @@
 
     this.moveSelectedMessages = function(dstFolder) {
       var moveSelectedMessage = vm.selectedFolder.hasSelectedMessage();
-      var selectedMessages = vm.selectedFolder.$selectedMessages();
-      var count = vm.selectedFolder.$selectedCount();
+      var selectedMessages = vm.selectedFolder.selectedMessages();
+      var count = vm.selectedFolder.selectedCount();
       if (_.size(selectedMessages) > 0)
         vm.selectedFolder.$moveMessages(selectedMessages, '/' + dstFolder).then(function(index) {
           $mdToast.show(
@@ -520,8 +517,11 @@
       var count = 0;
       _.forEach(_currentMailboxes(), function(folder) {
         var i = 0, length = folder.$messages.length;
-        for (; i < length; i++)
+        folder.$selectedMessages = [];
+        for (; i < length; i++) {
           folder.$messages[i].selected = true;
+          folder.$selectedMessages.push(folder.$messages[i]);
+        }
         count += length;
       });
       vm.mode.multiple = count;
@@ -529,6 +529,7 @@
 
     this.unselectMessages = function() {
       _.forEach(_currentMailboxes(), function(folder) {
+        folder.$selectedMessages = [];
         _.forEach(folder.$messages, function(message) {
           message.selected = false;
         });
@@ -537,7 +538,7 @@
     };
 
     this.markSelectedMessagesAsFlagged = function() {
-      var selectedMessages = vm.selectedFolder.$selectedMessages();
+      var selectedMessages = vm.selectedFolder.selectedMessages();
       if (_.size(selectedMessages) > 0)
         vm.selectedFolder.$flagMessages(selectedMessages, '\\Flagged', 'add').then(function(messages) {
           _.forEach(messages, function(message) {
@@ -547,7 +548,7 @@
     };
 
     this.markSelectedMessagesAsUnread = function() {
-      var selectedMessages = vm.selectedFolder.$selectedMessages();
+      var selectedMessages = vm.selectedFolder.selectedMessages();
       if (_.size(selectedMessages) > 0) {
         vm.selectedFolder.$flagMessages(selectedMessages, 'seen', 'remove').then(function(messages) {
           _.forEach(messages, function(message) {
@@ -560,7 +561,7 @@
     };
 
     this.markSelectedMessagesAsRead = function() {
-      var selectedMessages = vm.selectedFolder.$selectedMessages();
+      var selectedMessages = vm.selectedFolder.selectedMessages();
       if (_.size(selectedMessages) > 0) {
         vm.selectedFolder.$flagMessages(selectedMessages, 'seen', 'add').then(function(messages) {
           _.forEach(messages, function(message) {
diff -Nru sogo-5.0.1/UI/WebServerResources/js/Mailer/MailboxesController.js sogo-5.2.0/UI/WebServerResources/js/Mailer/MailboxesController.js
--- sogo-5.0.1/UI/WebServerResources/js/Mailer/MailboxesController.js	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/UI/WebServerResources/js/Mailer/MailboxesController.js	2021-08-18 21:35:57.000000000 +0200
@@ -34,7 +34,7 @@
 
       this.showSubscribedOnly = Preferences.defaults.SOGoMailShowSubscribedFoldersOnly;
 
-      this.refreshUnseenCount();
+      Account.refreshUnseenCount($window.unseenCountFolders);
 
       _registerHotkeys(hotkeys);
 
@@ -270,49 +270,6 @@
       }
     }; // delegate
 
-    this.refreshUnseenCount = function() {
-      var unseenCountFolders, refreshViewCheck;
-
-      if (Preferences.defaults.SOGoMailFetchAllUnseenCountFolders === 1)
-        unseenCountFolders = [];
-      else
-        unseenCountFolders = $window.unseenCountFolders;
-
-      _.forEach(vm.accounts, function(account) {
-        if (Preferences.defaults.SOGoMailFetchAllUnseenCountFolders === 1) {
-          // Include all mailboxes
-          _.forEach(account.$$flattenMailboxes, function(mailbox) {
-            unseenCountFolders.push(mailbox.id);
-          });
-        }
-        else {
-          // Always include the INBOX
-          if (!_.includes(unseenCountFolders, account.id + '/folderINBOX'))
-            unseenCountFolders.push(account.id + '/folderINBOX');
-
-          _.forEach(account.$$flattenMailboxes, function(mailbox) {
-            if (angular.isDefined(mailbox.unseenCount) &&
-                !_.includes(unseenCountFolders, mailbox.id))
-              unseenCountFolders.push(mailbox.id);
-          });
-        }
-      });
-
-      Account.$$resource.post('', 'unseenCount', {mailboxes: unseenCountFolders}).then(function(data) {
-        _.forEach(vm.accounts, function(account) {
-          _.forEach(account.$$flattenMailboxes, function(mailbox) {
-            if (data[mailbox.id]) {
-              mailbox.unseenCount = data[mailbox.id];
-            }
-          });
-        });
-      });
-
-      refreshViewCheck = Preferences.defaults.SOGoRefreshViewCheck;
-      if (refreshViewCheck && refreshViewCheck != 'manually')
-        $timeout(vm.refreshUnseenCount, refreshViewCheck.timeInterval()*1000);
-    };
-
     this.isDroppableFolder = function(srcFolder, dstFolder) {
       return (dstFolder.id != srcFolder.id) && !dstFolder.isNoSelect();
     };
@@ -321,11 +278,11 @@
       var dstId, messages, uids, clearMessageView, promise, success;
 
       dstId = '/' + dstFolder.id;
-      messages = srcFolder.$selectedMessages();
+      messages = srcFolder.selectedMessages();
       if (messages.length === 0)
-        messages = [srcFolder.$selectedMessage()];
+        messages = [srcFolder.selectedMessage()];
       uids = _.map(messages, 'uid');
-      clearMessageView = (srcFolder.selectedMessage && uids.indexOf(srcFolder.selectedMessage) >= 0);
+      clearMessageView = (srcFolder.$selectedMessage && uids.indexOf(srcFolder.$selectedMessage) >= 0);
 
       if (mode == 'copy') {
         promise = srcFolder.$copyMessages(messages, dstId);
